%define db_version 4.0.14
# Note: this list should only include platforms which have had glibc 2.0.x.
%define compat_arches %{ix86} alpha sparc
Summary: An NSS library for the Berkeley DB.
Name: nss_db
Version: 2.2
Release: 20.4
Source: ftp://sources.redhat.com/pub/glibc/releases/nss_db-%{version}.tar.gz
Source1: http://www.sleepycat.com/update/%{db_version}/db-%{db_version}.tar.gz
URL: http://sources.redhat.com/glibc/
Patch0: nss_db-2.2-external.patch
Patch1: nss_db-2.2-automake.patch
Patch2: nss_db-2.2-uniqdb.patch
Patch3: nss_db-2.2-compat.patch
Patch10: db-4.0.14-disable-mutex.patch
Patch11: db-4.0.14-libobjs.patch
License: GPL
Group: System Environment/Libraries
PreReq: /sbin/ldconfig
BuildPrereq: autoconf, automake15, libtool
Conflicts: glibc < 2.2
Requires: make
BuildRoot: %{_tmppath}/%{name}-root

%define _filter_GLIBC_PRIVATE  1

%description
Nss_db is a set of C library extensions which allow Berkeley Databases
to be used as a primary source of aliases, ethers, groups, hosts,
networks, protocol, users, RPCs, services, and shadow passwords
(instead of or in addition to using flat files or NIS). Install nss_db
if your flat name service files are too large and lookups are slow.

%package compat
Summary: An NSS compatibility library for Berkeley Databases and glibc 2.0.x.
Group: System Environment/Libraries
Requires: nss_db = %{version}-%{release}

%description compat
Nss_db-compat is a set of C library extensions which allow Berkeley
Databases to be used as a primary source of aliases, ethers, groups,
hosts, networks, protocol, users, RPCs, services, and shadow passwords
(instead of or in addition to using flat files or NIS) from programs
linked against glibc 2.0.x.

%prep
%setup -q -a 0 -a 1
%patch0 -p1 -b .external
%patch1 -p1 -b .automake
%patch2 -p1 -b .uniqdb
autoreconf -f -i

mv %{name}-%{version} %{name}-compat-%{version}
pushd %{name}-compat-%{version}
%patch0 -p1 -b .external
%patch1 -p1 -b .automake
%patch2 -p1 -b .uniqdb
%patch3 -p1 -b .compat
autoreconf -f -i
popd

# Basically we call the default find-requires script and grep out the
# GLIBC_PRIVATE dependency which we get by linking to internals of
# libnss_files.  It should go without saying that you should never do this
# unless you have a good idea of what you're doing, but I said it anyway.
find_requires=`rpm --eval %%{__find_requires}`
echo "$find_requires | grep -v GLIBC_PRIVATE" > find-requires
chmod +x find-requires

%patch10 -p0 -b .disable-mutex
%patch11 -p0 -b .libobjs
pushd db-%{db_version}/dist
./s_config
popd

%build
dbdir=`pwd`/db-instroot
CFLAGS="$RPM_OPT_FLAGS" ; export CFLAGS

pushd db-%{db_version}/dist
./configure -C \
	--disable-compat185 \
	--disable-cxx \
	--disable-diagnostic \
	--disable-dump185 \
	--disable-java \
	--disable-rpc \
	--disable-tcl \
	--disable-shared \
	--with-pic \
	--with-uniquename=_nssdb \
	--prefix=$dbdir
make
make install
popd

%configure --with-db=${dbdir}
make

pushd %{name}-compat-%{version}
%configure --with-db=${dbdir}
make
popd

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
install -m755 -d ${RPM_BUILD_ROOT}/{%{_lib},/var/db,%{_bindir}}
install -m644 db-Makefile ${RPM_BUILD_ROOT}/var/db/Makefile
install -m755 makedb ${RPM_BUILD_ROOT}/%{_bindir}/
install -m755 .libs/libnss_db.so.[0-9]* ${RPM_BUILD_ROOT}/%{_lib}/

%ifarch %{compat_arches}

pushd %{name}-compat-%{version}
install -m755 .libs/libnss_db.so.[0-9]* ${RPM_BUILD_ROOT}/%{_lib}/
popd

%endif

# Remove the sonames which we don't package.
rm -f ${RPM_BUILD_ROOT}/%{_lib}/libnss_db.so.?

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING* ChangeLog NEWS README THANKS
/%{_lib}/libnss_db*2.*
%{_bindir}/makedb
%config /var/db/*

%ifarch %{compat_arches}

%files compat
%defattr(-,root,root)
/%{_lib}/libnss_db*1.*

%post compat -p /sbin/ldconfig

%postun compat -p /sbin/ldconfig

%endif

%changelog
* Thu Jul 29 2004 Nalin Dahyabhai <nalin@redhat.com> 2.2-20.4
- follow instructions from #128436 to let file colors be determined

* Tue Jul 27 2004 Nalin Dahyabhai <nalin@redhat.com> 2.2-20.3
- rebuild for #128436 to get file coloring

* Mon Jul 12 2004 Nalin Dahyabhai <nalin@redhat.com> 2.2-20.2
- rebuild

* Fri Jul  9 2004 Nalin Dahyabhai <nalin@redhat.com> 2.2-20.1
- pull in changes from HEAD:
  - only provide a -compat subpackage on platforms where glibc provides
    compat NSS modules (%%{ix86})
  - make -compat depend on the same version of the non-compat package
  - disable use of RPM's internal dependency generator, which was preventing
    the filtering out of glibc private dependencies (#112849)
  - find bundled libdb again (#111004)
  - disable mutex locking

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan 14 2003 Nalin Dahyabhai <nalin@redhat.com> 2.2-19
- force use of assembly mutexes on %%{ix86} to avoid dependency on libpthread

* Thu Nov 14 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-18
- disable various language bindings when building the bundled DB library
- remove unpackaged files from the buildroot in %%install
- don't install the compat version on arches where if we don't need one

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Fri May 17 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-15
- rebuild in new environment

* Mon Apr 15 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-14
- rebuild

* Mon Apr 15 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-13
- whoops, __set_errno() is a glibc-internal symbol as well (#63373)

* Wed Apr  3 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-12
- filter out dependency on glibc private symbols

* Tue Apr  2 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-11
- don't use libc-internal symbols and interfaces

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-10
- rebuild

* Fri Feb 22 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-9
- rebuild

* Mon Feb 18 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-8
- build using a bundled Berkeley DB with a unique name to avoid possible symbol
  collisions with binaries using different versions (mix multiple versions of
  any shared library in a single process, observe as wackiness ensues)

* Wed Jan 23 2002 Nalin Dahyabhai <nalin@redhat.com> 2.2-7
- rebuild against db4-devel

* Mon Aug  6 2001 Nalin Dahyabhai <nalin@redhat.com> 2.2-6
- require db3-devel at build-time, not db3 (#49544)

* Tue May 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- don't include copies of the shared libraries with the soname for their names

* Thu May 24 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Tue Feb 27 2001 Nalin Dahyabhai <nalin@redhat.com>
- don't own /var/db, the filesystem package does

* Tue Feb 13 2001 Nalin Dahyabhai <nalin@redhat.com>
- require make (#27313)
- add the docs to the package

* Tue Dec 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.2

* Thu Sep 14 2000 Jakub Jelinek <jakub@redhat.com>
- separate from db3
